//+------------------------------------------------------------------+
//| Digital High Pass (KGHP) Filter                                  |
//| Created by newdigital                                            |
//| Using the Generator of Digital Filters                           |
//| http://www.forex-tsd.com/                                        |
//+------------------------------------------------------------------+
#property copyright "newdigital"
#property link      "http://www.forex-tsd.com/"
/*I wanted to create the KGHP digital filter and was failed.
But when I attached this indicator to the indicator window together
with other filters (in one indicator window) I recognized that 
it is great indicator. It follows the price and seems it is like 
the price curve in the indicator window. Just attach an other filter to
the same window and this KGHP indicator will be as price curve.
It is very easy to analyze everything.*/
// --- Parameters: P1=30, D1=29, A1=40
// --- P2=52, D2=31, A2=40, Ripple=0.08, Delay=0
// --- Order [Auto]=858, Calculate method=2


#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     Red
#property indicator_color4     SlateGray
#property indicator_color5     SlateGray
#property indicator_color6     SlateGray
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_style4     STYLE_DASH
#property indicator_style5     STYLE_DASHDOTDOT
#property indicator_style6     STYLE_DASH
#property indicator_level1     0
#property indicator_levelcolor DarkOrchid

//
//
//
//
//

extern string note_TimeFrames          = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string TimeFrame                = "Current time frame";
extern double kgspSmoothLength         = 5;
extern double kgspSmoothPhase          = 0;
extern bool   kgspSmoothDouble         = true;
extern int    VolatilityBandPeriod     = 34;
extern int    VolatilityBandMAMode     = MODE_LWMA;
extern double VolatilityBandMultiplier = 1.6185; 
extern bool   Interpolate              = true;
extern bool   MultiColor               = true;

extern bool   alertsOn                 = true;
extern bool   alertsOnCurrent          = false;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = false;
extern bool   alertsEmail              = false;

//
//
//
//
//

double kgsp[];
double kgspUa[];
double kgspUb[];
double bandsUp[];
double bandsMi[];
double bandsDo[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//
//
//
//
//

int init()
  {
 IndicatorBuffers(7);
   SetIndexBuffer(0,kgsp);
   SetIndexBuffer(1,kgspUa);
   SetIndexBuffer(2,kgspUb);
   SetIndexBuffer(3,bandsMi);
   SetIndexBuffer(4,bandsUp);
   SetIndexBuffer(5,bandsDo);
   SetIndexBuffer(6,trend);
   
   //
   //
   //
   //
   //
   
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
   
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" jurik Kgsp bands ");
   
   return(0);
}

//
//
//
//
//  
  
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
  
int start()
  {
   
   int counted_bars=IndicatorCounted();
   int i,n,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { kgsp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
   
   //
   //
   //
   //
   //
    
   for (i=limit-1; i>=0; i--)
   {  

   double value1 =
   1.000000000000*Close[i+0]
   +0.000000000000000039*Close[i+1]
   -0.000000000000000038*Close[i+2]
   +0.000000000000000038*Close[i+3]
   -0.000000000000000039*Close[i+4]
   +0.000000000000000039*Close[i+5]
   -0.000000000000000039*Close[i+6]
   +0.000000000000000038*Close[i+7]
   -0.000000000000000039*Close[i+8]
   +0.000000000000000039*Close[i+9]
   -0.000000000000000039*Close[i+10]
   +0.000000000000000038*Close[i+11]
   -0.000000000000000039*Close[i+12]
   +0.000000000000000039*Close[i+13]
   -0.000000000000000039*Close[i+14]
   +0.000000000000000038*Close[i+15]
   -0.000000000000000039*Close[i+16]
   +0.000000000000000039*Close[i+17]
   -0.000000000000000039*Close[i+18]
   +0.000000000000000038*Close[i+19]
   -0.000000000000000039*Close[i+20]
   +0.000000000000000039*Close[i+21]
   -0.000000000000000038*Close[i+22]
   +0.000000000000000039*Close[i+23]
   -0.000000000000000039*Close[i+24]
   +0.000000000000000039*Close[i+25]
   -0.000000000000000039*Close[i+26]
   +0.000000000000000038*Close[i+27]
   -0.000000000000000039*Close[i+28]
   +0.000000000000000039*Close[i+29]
   -0.000000000000000039*Close[i+30]
   +0.000000000000000038*Close[i+31]
   -0.000000000000000039*Close[i+32]
   +0.000000000000000039*Close[i+33]
   -0.000000000000000039*Close[i+34]
   +0.000000000000000039*Close[i+35]
   -0.000000000000000039*Close[i+36]
   +0.000000000000000039*Close[i+37]
   -0.000000000000000039*Close[i+38]
   +0.000000000000000039*Close[i+39]
   -0.000000000000000039*Close[i+40]
   +0.000000000000000039*Close[i+41]
   -0.000000000000000039*Close[i+42]
   +0.000000000000000039*Close[i+43]
   -0.000000000000000039*Close[i+44]
   +0.000000000000000039*Close[i+45]
   -0.000000000000000039*Close[i+46]
   +0.000000000000000039*Close[i+47]
   -0.000000000000000039*Close[i+48]
   +0.000000000000000039*Close[i+49]
   -0.000000000000000039*Close[i+50]
   +0.000000000000000039*Close[i+51]
   -0.000000000000000039*Close[i+52]
   +0.000000000000000039*Close[i+53]
   -0.000000000000000039*Close[i+54]
   +0.000000000000000039*Close[i+55]
   -0.000000000000000039*Close[i+56]
   +0.000000000000000039*Close[i+57]
   -0.000000000000000039*Close[i+58]
   +0.000000000000000039*Close[i+59]
   -0.000000000000000039*Close[i+60]
   +0.000000000000000039*Close[i+61]
   -0.000000000000000039*Close[i+62]
   +0.000000000000000039*Close[i+63]
   -0.000000000000000039*Close[i+64]
   +0.000000000000000039*Close[i+65]
   -0.000000000000000039*Close[i+66]
   +0.000000000000000039*Close[i+67]
   -0.000000000000000039*Close[i+68]
   +0.000000000000000039*Close[i+69]
   -0.000000000000000039*Close[i+70]
   +0.000000000000000039*Close[i+71]
   -0.000000000000000039*Close[i+72]
   +0.000000000000000039*Close[i+73]
   -0.000000000000000039*Close[i+74]
   +0.000000000000000039*Close[i+75]
   -0.000000000000000039*Close[i+76]
   +0.000000000000000039*Close[i+77]
   -0.000000000000000039*Close[i+78]
   +0.000000000000000039*Close[i+79]
   -0.000000000000000039*Close[i+80]
   +0.000000000000000039*Close[i+81]
   -0.000000000000000039*Close[i+82]
   +0.000000000000000039*Close[i+83]
   -0.000000000000000039*Close[i+84]
   +0.000000000000000039*Close[i+85]
   -0.000000000000000039*Close[i+86]
   +0.000000000000000039*Close[i+87]
   -0.000000000000000039*Close[i+88]
   +0.000000000000000039*Close[i+89]
   -0.000000000000000039*Close[i+90]
   +0.000000000000000039*Close[i+91]
   -0.000000000000000039*Close[i+92]
   +0.000000000000000039*Close[i+93]
   -0.000000000000000039*Close[i+94]
   +0.000000000000000039*Close[i+95]
   -0.000000000000000039*Close[i+96]
   +0.000000000000000039*Close[i+97]
   -0.000000000000000039*Close[i+98]
   +0.000000000000000039*Close[i+99]
   -0.000000000000000039*Close[i+100]
   +0.000000000000000039*Close[i+101]
   -0.000000000000000039*Close[i+102]
   +0.000000000000000039*Close[i+103]
   -0.000000000000000039*Close[i+104]
   +0.000000000000000039*Close[i+105]
   -0.000000000000000039*Close[i+106]
   +0.000000000000000039*Close[i+107]
   -0.000000000000000039*Close[i+108]
   +0.000000000000000039*Close[i+109]
   -0.000000000000000039*Close[i+110]
   +0.000000000000000039*Close[i+111]
   -0.000000000000000039*Close[i+112]
   +0.000000000000000039*Close[i+113]
   -0.000000000000000039*Close[i+114]
   +0.000000000000000039*Close[i+115]
   -0.000000000000000039*Close[i+116]
   +0.000000000000000039*Close[i+117]
   -0.000000000000000039*Close[i+118]
   +0.000000000000000039*Close[i+119]
   -0.000000000000000039*Close[i+120]
   +0.000000000000000039*Close[i+121]
   -0.000000000000000039*Close[i+122]
   +0.000000000000000039*Close[i+123]
   -0.000000000000000039*Close[i+124]
   +0.000000000000000039*Close[i+125]
   -0.000000000000000039*Close[i+126]
   +0.000000000000000039*Close[i+127]
   -0.000000000000000039*Close[i+128]
   +0.000000000000000039*Close[i+129]
   -0.000000000000000039*Close[i+130]
   +0.000000000000000039*Close[i+131]
   -0.000000000000000039*Close[i+132]
   +0.000000000000000039*Close[i+133]
   -0.000000000000000039*Close[i+134]
   +0.000000000000000039*Close[i+135]
   -0.000000000000000039*Close[i+136]
   +0.000000000000000039*Close[i+137]
   -0.000000000000000039*Close[i+138]
   +0.000000000000000039*Close[i+139]
   -0.000000000000000039*Close[i+140]
   +0.000000000000000039*Close[i+141]
   -0.000000000000000039*Close[i+142]
   +0.000000000000000039*Close[i+143]
   -0.000000000000000039*Close[i+144]
   +0.000000000000000039*Close[i+145]
   -0.000000000000000039*Close[i+146]
   +0.000000000000000039*Close[i+147]
   -0.000000000000000039*Close[i+148]
   +0.000000000000000039*Close[i+149]
   -0.000000000000000039*Close[i+150]
   +0.000000000000000039*Close[i+151]
   -0.000000000000000039*Close[i+152]
   +0.000000000000000039*Close[i+153]
   -0.000000000000000039*Close[i+154]
   +0.000000000000000039*Close[i+155]
   -0.000000000000000039*Close[i+156]
   +0.000000000000000039*Close[i+157]
   -0.000000000000000039*Close[i+158]
   +0.000000000000000039*Close[i+159]
   -0.000000000000000039*Close[i+160]
   +0.000000000000000039*Close[i+161]
   -0.000000000000000039*Close[i+162]
   +0.000000000000000039*Close[i+163]
   -0.000000000000000039*Close[i+164]
   +0.000000000000000039*Close[i+165]
   -0.000000000000000039*Close[i+166]
   +0.000000000000000039*Close[i+167]
   -0.000000000000000039*Close[i+168]
   +0.000000000000000039*Close[i+169]
   -0.000000000000000039*Close[i+170]
   +0.000000000000000039*Close[i+171]
   -0.000000000000000039*Close[i+172]
   +0.000000000000000039*Close[i+173]
   -0.000000000000000039*Close[i+174]
   +0.000000000000000039*Close[i+175]
   -0.000000000000000039*Close[i+176]
   +0.000000000000000040*Close[i+177]
   -0.000000000000000039*Close[i+178]
   +0.000000000000000039*Close[i+179]
   -0.000000000000000039*Close[i+180]
   +0.000000000000000039*Close[i+181]
   -0.000000000000000039*Close[i+182]
   +0.000000000000000039*Close[i+183]
   -0.000000000000000039*Close[i+184]
   +0.000000000000000039*Close[i+185]
   -0.000000000000000039*Close[i+186]
   +0.000000000000000039*Close[i+187]
   -0.000000000000000039*Close[i+188]
   +0.000000000000000039*Close[i+189]
   -0.000000000000000039*Close[i+190]
   +0.000000000000000039*Close[i+191]
   -0.000000000000000039*Close[i+192]
   +0.000000000000000039*Close[i+193]
   -0.000000000000000039*Close[i+194]
   +0.000000000000000039*Close[i+195]
   -0.000000000000000039*Close[i+196]
   +0.000000000000000039*Close[i+197]
   -0.000000000000000039*Close[i+198]
   +0.000000000000000039*Close[i+199]
   -0.000000000000000039*Close[i+200]
   +0.000000000000000039*Close[i+201]
   -0.000000000000000039*Close[i+202]
   +0.000000000000000039*Close[i+203]
   -0.000000000000000039*Close[i+204]
   +0.000000000000000039*Close[i+205]
   -0.000000000000000039*Close[i+206]
   +0.000000000000000040*Close[i+207]
   -0.000000000000000040*Close[i+208]
   +0.000000000000000041*Close[i+209]
   -0.000000000000000039*Close[i+210]
   +0.000000000000000039*Close[i+211]
   -0.000000000000000040*Close[i+212]
   +0.000000000000000039*Close[i+213]
   -0.000000000000000039*Close[i+214]
   +0.000000000000000039*Close[i+215]
   -0.000000000000000040*Close[i+216]
   +0.000000000000000039*Close[i+217]
   -0.000000000000000040*Close[i+218]
   +0.000000000000000039*Close[i+219]
   -0.000000000000000040*Close[i+220]
   +0.000000000000000039*Close[i+221]
   -0.000000000000000040*Close[i+222]
   +0.000000000000000040*Close[i+223]
   -0.000000000000000040*Close[i+224]
   +0.000000000000000040*Close[i+225]
   -0.000000000000000040*Close[i+226]
   +0.000000000000000040*Close[i+227]
   -0.000000000000000040*Close[i+228]
   +0.000000000000000040*Close[i+229]
   -0.000000000000000040*Close[i+230]
   +0.000000000000000040*Close[i+231]
   -0.000000000000000040*Close[i+232]
   +0.000000000000000040*Close[i+233]
   -0.000000000000000040*Close[i+234]
   +0.000000000000000040*Close[i+235]
   -0.000000000000000040*Close[i+236]
   +0.000000000000000040*Close[i+237]
   -0.000000000000000040*Close[i+238]
   +0.000000000000000040*Close[i+239]
   -0.000000000000000040*Close[i+240]
   +0.000000000000000040*Close[i+241]
   -0.000000000000000040*Close[i+242]
   +0.000000000000000040*Close[i+243]
   -0.000000000000000040*Close[i+244]
   +0.000000000000000040*Close[i+245]
   -0.000000000000000040*Close[i+246]
   +0.000000000000000040*Close[i+247]
   -0.000000000000000040*Close[i+248]
   +0.000000000000000040*Close[i+249]
   -0.000000000000000040*Close[i+250]
   +0.000000000000000040*Close[i+251]
   -0.000000000000000041*Close[i+252]
   +0.000000000000000040*Close[i+253]
   -0.000000000000000040*Close[i+254]
   +0.000000000000000040*Close[i+255]
   -0.000000000000000040*Close[i+256]
   +0.000000000000000040*Close[i+257]
   -0.000000000000000040*Close[i+258]
   +0.000000000000000040*Close[i+259]
   -0.000000000000000040*Close[i+260]
   +0.000000000000000040*Close[i+261]
   -0.000000000000000040*Close[i+262]
   +0.000000000000000040*Close[i+263]
   -0.000000000000000040*Close[i+264]
   +0.000000000000000040*Close[i+265]
   -0.000000000000000040*Close[i+266]
   +0.000000000000000040*Close[i+267]
   -0.000000000000000040*Close[i+268]
   +0.000000000000000040*Close[i+269]
   -0.000000000000000040*Close[i+270]
   +0.000000000000000040*Close[i+271]
   -0.000000000000000040*Close[i+272]
   +0.000000000000000040*Close[i+273]
   -0.000000000000000040*Close[i+274]
   +0.000000000000000040*Close[i+275]
   -0.000000000000000040*Close[i+276]
   +0.000000000000000041*Close[i+277]
   -0.000000000000000040*Close[i+278]
   +0.000000000000000040*Close[i+279]
   -0.000000000000000041*Close[i+280]
   +0.000000000000000040*Close[i+281]
   -0.000000000000000040*Close[i+282]
   +0.000000000000000040*Close[i+283]
   -0.000000000000000041*Close[i+284]
   +0.000000000000000040*Close[i+285]
   -0.000000000000000040*Close[i+286]
   +0.000000000000000041*Close[i+287]
   -0.000000000000000040*Close[i+288]
   +0.000000000000000040*Close[i+289]
   -0.000000000000000040*Close[i+290]
   +0.000000000000000040*Close[i+291]
   -0.000000000000000040*Close[i+292]
   +0.000000000000000041*Close[i+293]
   -0.000000000000000040*Close[i+294]
   +0.000000000000000040*Close[i+295]
   -0.000000000000000041*Close[i+296]
   +0.000000000000000041*Close[i+297]
   -0.000000000000000040*Close[i+298]
   +0.000000000000000041*Close[i+299]
   -0.000000000000000040*Close[i+300]
   +0.000000000000000040*Close[i+301]
   -0.000000000000000041*Close[i+302]
   +0.000000000000000041*Close[i+303]
   -0.000000000000000040*Close[i+304]
   +0.000000000000000041*Close[i+305]
   -0.000000000000000041*Close[i+306]
   +0.000000000000000041*Close[i+307]
   -0.000000000000000041*Close[i+308]
   +0.000000000000000041*Close[i+309]
   -0.000000000000000041*Close[i+310]
   +0.000000000000000041*Close[i+311]
   -0.000000000000000041*Close[i+312]
   +0.000000000000000041*Close[i+313]
   -0.000000000000000041*Close[i+314]
   +0.000000000000000041*Close[i+315]
   -0.000000000000000041*Close[i+316]
   +0.000000000000000041*Close[i+317]
   -0.000000000000000041*Close[i+318]
   +0.000000000000000041*Close[i+319]
   -0.000000000000000041*Close[i+320]
   +0.000000000000000041*Close[i+321]
   -0.000000000000000041*Close[i+322]
   +0.000000000000000041*Close[i+323]
   -0.000000000000000041*Close[i+324]
   +0.000000000000000041*Close[i+325]
   -0.000000000000000041*Close[i+326]
   +0.000000000000000041*Close[i+327]
   -0.000000000000000041*Close[i+328]
   +0.000000000000000041*Close[i+329]
   -0.000000000000000041*Close[i+330]
   +0.000000000000000041*Close[i+331]
   -0.000000000000000041*Close[i+332]
   +0.000000000000000041*Close[i+333]
   -0.000000000000000041*Close[i+334]
   +0.000000000000000041*Close[i+335]
   -0.000000000000000041*Close[i+336]
   +0.000000000000000041*Close[i+337]
   -0.000000000000000041*Close[i+338]
   +0.000000000000000041*Close[i+339]
   -0.000000000000000042*Close[i+340]
   +0.000000000000000041*Close[i+341]
   -0.000000000000000041*Close[i+342]
   +0.000000000000000041*Close[i+343]
   -0.000000000000000041*Close[i+344]
   +0.000000000000000041*Close[i+345]
   -0.000000000000000041*Close[i+346]
   +0.000000000000000041*Close[i+347]
   -0.000000000000000043*Close[i+348]
   +0.000000000000000041*Close[i+349]
   -0.000000000000000041*Close[i+350]
   +0.000000000000000041*Close[i+351]
   -0.000000000000000041*Close[i+352]
   +0.000000000000000041*Close[i+353]
   -0.000000000000000041*Close[i+354]
   +0.000000000000000041*Close[i+355]
   -0.000000000000000041*Close[i+356]
   +0.000000000000000041*Close[i+357]
   -0.000000000000000042*Close[i+358]
   +0.000000000000000041*Close[i+359]
   -0.000000000000000042*Close[i+360]
   +0.000000000000000042*Close[i+361]
   -0.000000000000000042*Close[i+362]
   +0.000000000000000042*Close[i+363]
   -0.000000000000000042*Close[i+364]
   +0.000000000000000042*Close[i+365]
   -0.000000000000000042*Close[i+366]
   +0.000000000000000042*Close[i+367]
   -0.000000000000000042*Close[i+368]
   +0.000000000000000042*Close[i+369]
   -0.000000000000000042*Close[i+370]
   +0.000000000000000042*Close[i+371]
   -0.000000000000000042*Close[i+372]
   +0.000000000000000042*Close[i+373]
   -0.000000000000000042*Close[i+374]
   +0.000000000000000042*Close[i+375]
   -0.000000000000000041*Close[i+376]
   +0.000000000000000042*Close[i+377]
   -0.000000000000000042*Close[i+378]
   +0.000000000000000042*Close[i+379]
   -0.000000000000000042*Close[i+380]
   +0.000000000000000042*Close[i+381]
   -0.000000000000000043*Close[i+382]
   +0.000000000000000042*Close[i+383]
   -0.000000000000000042*Close[i+384]
   +0.000000000000000042*Close[i+385]
   -0.000000000000000042*Close[i+386]
   +0.000000000000000041*Close[i+387]
   -0.000000000000000042*Close[i+388]
   +0.000000000000000042*Close[i+389]
   -0.000000000000000042*Close[i+390]
   +0.000000000000000042*Close[i+391]
   -0.000000000000000042*Close[i+392]
   +0.000000000000000042*Close[i+393]
   -0.000000000000000042*Close[i+394]
   +0.000000000000000042*Close[i+395]
   -0.000000000000000042*Close[i+396]
   +0.000000000000000042*Close[i+397]
   -0.000000000000000042*Close[i+398]
   +0.000000000000000042*Close[i+399]
   -0.000000000000000042*Close[i+400]
   +0.000000000000000042*Close[i+401]
   -0.000000000000000042*Close[i+402]
   +0.000000000000000042*Close[i+403]
   -0.000000000000000042*Close[i+404]
   +0.000000000000000042*Close[i+405]
   -0.000000000000000043*Close[i+406]
   +0.000000000000000043*Close[i+407]
   -0.000000000000000042*Close[i+408]
   +0.000000000000000042*Close[i+409]
   -0.000000000000000043*Close[i+410]
   +0.000000000000000043*Close[i+411]
   -0.000000000000000042*Close[i+412]
   +0.000000000000000043*Close[i+413]
   -0.000000000000000042*Close[i+414]
   +0.000000000000000041*Close[i+415]
   -0.000000000000000043*Close[i+416]
   +0.000000000000000043*Close[i+417]
   -0.000000000000000042*Close[i+418]
   +0.000000000000000042*Close[i+419]
   -0.000000000000000043*Close[i+420]
   +0.000000000000000042*Close[i+421]
   -0.000000000000000043*Close[i+422]
   +0.000000000000000042*Close[i+423]
   -0.000000000000000043*Close[i+424]
   +0.000000000000000043*Close[i+425]
   -0.000000000000000043*Close[i+426]
   +0.000000000000000043*Close[i+427]
   -0.000000000000000043*Close[i+428]
   +0.000000000000000043*Close[i+429]
   -0.000000000000000043*Close[i+430]
   +0.000000000000000043*Close[i+431]
   -0.000000000000000043*Close[i+432]
   +0.000000000000000043*Close[i+433]
   -0.000000000000000043*Close[i+434]
   +0.000000000000000043*Close[i+435]
   -0.000000000000000043*Close[i+436]
   +0.000000000000000043*Close[i+437]
   -0.000000000000000043*Close[i+438]
   +0.000000000000000043*Close[i+439]
   -0.000000000000000043*Close[i+440]
   +0.000000000000000043*Close[i+441]
   -0.000000000000000043*Close[i+442]
   +0.000000000000000043*Close[i+443]
   -0.000000000000000043*Close[i+444]
   +0.000000000000000043*Close[i+445]
   -0.000000000000000043*Close[i+446]
   +0.000000000000000043*Close[i+447]
   -0.000000000000000043*Close[i+448]
   +0.000000000000000043*Close[i+449]
   -0.000000000000000047*Close[i+450]
   +0.000000000000000043*Close[i+451]
   -0.000000000000000044*Close[i+452]
   +0.000000000000000043*Close[i+453]
   -0.000000000000000043*Close[i+454]
   +0.000000000000000043*Close[i+455]
   -0.000000000000000043*Close[i+456]
   +0.000000000000000042*Close[i+457]
   -0.000000000000000043*Close[i+458]
   +0.000000000000000044*Close[i+459]
   -0.000000000000000043*Close[i+460]
   +0.000000000000000044*Close[i+461]
   -0.000000000000000044*Close[i+462]
   +0.000000000000000044*Close[i+463]
   -0.000000000000000044*Close[i+464]
   +0.000000000000000044*Close[i+465]
   -0.000000000000000044*Close[i+466]
   +0.000000000000000044*Close[i+467]
   -0.000000000000000044*Close[i+468]
   +0.000000000000000044*Close[i+469]
   -0.000000000000000044*Close[i+470]
   +0.000000000000000044*Close[i+471]
   -0.000000000000000044*Close[i+472]
   +0.000000000000000044*Close[i+473]
   -0.000000000000000044*Close[i+474]
   +0.000000000000000044*Close[i+475]
   -0.000000000000000044*Close[i+476]
   +0.000000000000000044*Close[i+477]
   -0.000000000000000044*Close[i+478]
   +0.000000000000000044*Close[i+479]
   -0.000000000000000044*Close[i+480]
   +0.000000000000000044*Close[i+481]
   -0.000000000000000045*Close[i+482]
   +0.000000000000000044*Close[i+483]
   -0.000000000000000044*Close[i+484]
   +0.000000000000000044*Close[i+485]
   -0.000000000000000044*Close[i+486]
   +0.000000000000000044*Close[i+487]
   -0.000000000000000044*Close[i+488]
   +0.000000000000000044*Close[i+489]
   -0.000000000000000044*Close[i+490]
   +0.000000000000000045*Close[i+491]
   -0.000000000000000044*Close[i+492]
   +0.000000000000000044*Close[i+493]
   -0.000000000000000044*Close[i+494]
   +0.000000000000000044*Close[i+495]
   -0.000000000000000044*Close[i+496]
   +0.000000000000000044*Close[i+497]
   -0.000000000000000045*Close[i+498]
   +0.000000000000000045*Close[i+499]
   -0.000000000000000044*Close[i+500]
   +0.000000000000000044*Close[i+501]
   -0.000000000000000044*Close[i+502]
   +0.000000000000000045*Close[i+503]
   -0.000000000000000045*Close[i+504]
   +0.000000000000000045*Close[i+505]
   -0.000000000000000045*Close[i+506]
   +0.000000000000000045*Close[i+507]
   -0.000000000000000044*Close[i+508]
   +0.000000000000000045*Close[i+509]
   -0.000000000000000045*Close[i+510]
   +0.000000000000000045*Close[i+511]
   -0.000000000000000045*Close[i+512]
   +0.000000000000000045*Close[i+513]
   -0.000000000000000045*Close[i+514]
   +0.000000000000000045*Close[i+515]
   -0.000000000000000045*Close[i+516]
   +0.000000000000000045*Close[i+517]
   -0.000000000000000045*Close[i+518]
   +0.000000000000000045*Close[i+519]
   -0.000000000000000045*Close[i+520]
   +0.000000000000000045*Close[i+521]
   -0.000000000000000043*Close[i+522]
   +0.000000000000000046*Close[i+523]
   -0.000000000000000045*Close[i+524]
   +0.000000000000000045*Close[i+525]
   -0.000000000000000045*Close[i+526]
   +0.000000000000000045*Close[i+527]
   -0.000000000000000045*Close[i+528]
   +0.000000000000000046*Close[i+529]
   -0.000000000000000045*Close[i+530]
   +0.000000000000000046*Close[i+531]
   -0.000000000000000046*Close[i+532]
   +0.000000000000000046*Close[i+533]
   -0.000000000000000046*Close[i+534]
   +0.000000000000000045*Close[i+535]
   -0.000000000000000046*Close[i+536]
   +0.000000000000000045*Close[i+537]
   -0.000000000000000046*Close[i+538]
   +0.000000000000000046*Close[i+539]
   -0.000000000000000046*Close[i+540]
   +0.000000000000000045*Close[i+541]
   -0.000000000000000046*Close[i+542]
   +0.000000000000000046*Close[i+543]
   -0.000000000000000046*Close[i+544]
   +0.000000000000000046*Close[i+545]
   -0.000000000000000046*Close[i+546]
   +0.000000000000000045*Close[i+547]
   -0.000000000000000046*Close[i+548]
   +0.000000000000000046*Close[i+549]
   -0.000000000000000046*Close[i+550]
   +0.000000000000000046*Close[i+551]
   -0.000000000000000046*Close[i+552]
   +0.000000000000000046*Close[i+553]
   -0.000000000000000046*Close[i+554]
   +0.000000000000000046*Close[i+555]
   -0.000000000000000046*Close[i+556]
   +0.000000000000000046*Close[i+557]
   -0.000000000000000044*Close[i+558]
   +0.000000000000000046*Close[i+559]
   -0.000000000000000046*Close[i+560]
   +0.000000000000000046*Close[i+561]
   -0.000000000000000046*Close[i+562]
   +0.000000000000000046*Close[i+563]
   -0.000000000000000046*Close[i+564]
   +0.000000000000000047*Close[i+565]
   -0.000000000000000047*Close[i+566]
   +0.000000000000000046*Close[i+567]
   -0.000000000000000047*Close[i+568]
   +0.000000000000000047*Close[i+569]
   -0.000000000000000047*Close[i+570]
   +0.000000000000000046*Close[i+571]
   -0.000000000000000047*Close[i+572]
   +0.000000000000000046*Close[i+573]
   -0.000000000000000047*Close[i+574]
   +0.000000000000000047*Close[i+575]
   -0.000000000000000047*Close[i+576]
   +0.000000000000000047*Close[i+577]
   -0.000000000000000047*Close[i+578]
   +0.000000000000000047*Close[i+579]
   -0.000000000000000046*Close[i+580]
   +0.000000000000000047*Close[i+581]
   -0.000000000000000047*Close[i+582]
   +0.000000000000000047*Close[i+583]
   -0.000000000000000047*Close[i+584]
   +0.000000000000000047*Close[i+585]
   -0.000000000000000047*Close[i+586]
   +0.000000000000000047*Close[i+587]
   -0.000000000000000047*Close[i+588]
   +0.000000000000000047*Close[i+589]
   -0.000000000000000048*Close[i+590]
   +0.000000000000000047*Close[i+591]
   -0.000000000000000048*Close[i+592]
   +0.000000000000000048*Close[i+593]
   -0.000000000000000048*Close[i+594]
   +0.000000000000000048*Close[i+595]
   -0.000000000000000049*Close[i+596]
   +0.000000000000000047*Close[i+597]
   -0.000000000000000047*Close[i+598]
   +0.000000000000000046*Close[i+599]
   -0.000000000000000048*Close[i+600]
   +0.000000000000000048*Close[i+601]
   -0.000000000000000048*Close[i+602]
   +0.000000000000000048*Close[i+603]
   -0.000000000000000048*Close[i+604]
   +0.000000000000000048*Close[i+605]
   -0.000000000000000048*Close[i+606]
   +0.000000000000000048*Close[i+607]
   -0.000000000000000048*Close[i+608]
   +0.000000000000000048*Close[i+609]
   -0.000000000000000048*Close[i+610]
   +0.000000000000000048*Close[i+611]
   -0.000000000000000048*Close[i+612]
   +0.000000000000000048*Close[i+613]
   -0.000000000000000048*Close[i+614]
   +0.000000000000000048*Close[i+615]
   -0.000000000000000048*Close[i+616]
   +0.000000000000000048*Close[i+617]
   -0.000000000000000048*Close[i+618]
   +0.000000000000000048*Close[i+619]
   -0.000000000000000048*Close[i+620]
   +0.000000000000000048*Close[i+621]
   -0.000000000000000049*Close[i+622]
   +0.000000000000000049*Close[i+623]
   -0.000000000000000049*Close[i+624]
   +0.000000000000000049*Close[i+625]
   -0.000000000000000048*Close[i+626]
   +0.000000000000000049*Close[i+627]
   -0.000000000000000052*Close[i+628]
   +0.000000000000000049*Close[i+629]
   -0.000000000000000049*Close[i+630]
   +0.000000000000000049*Close[i+631]
   -0.000000000000000049*Close[i+632]
   +0.000000000000000049*Close[i+633]
   -0.000000000000000049*Close[i+634]
   +0.000000000000000049*Close[i+635]
   -0.000000000000000049*Close[i+636]
   +0.000000000000000049*Close[i+637]
   -0.000000000000000049*Close[i+638]
   +0.000000000000000049*Close[i+639]
   -0.000000000000000049*Close[i+640]
   +0.000000000000000049*Close[i+641]
   -0.000000000000000049*Close[i+642]
   +0.000000000000000049*Close[i+643]
   -0.000000000000000049*Close[i+644]
   +0.000000000000000049*Close[i+645]
   -0.000000000000000049*Close[i+646]
   +0.000000000000000050*Close[i+647]
   -0.000000000000000050*Close[i+648]
   +0.000000000000000050*Close[i+649]
   -0.000000000000000049*Close[i+650]
   +0.000000000000000050*Close[i+651]
   -0.000000000000000050*Close[i+652]
   +0.000000000000000050*Close[i+653]
   -0.000000000000000050*Close[i+654]
   +0.000000000000000050*Close[i+655]
   -0.000000000000000050*Close[i+656]
   +0.000000000000000050*Close[i+657]
   -0.000000000000000049*Close[i+658]
   +0.000000000000000050*Close[i+659]
   -0.000000000000000050*Close[i+660]
   +0.000000000000000050*Close[i+661]
   -0.000000000000000051*Close[i+662]
   +0.000000000000000050*Close[i+663]
   -0.000000000000000050*Close[i+664]
   +0.000000000000000050*Close[i+665]
   -0.000000000000000050*Close[i+666]
   +0.000000000000000051*Close[i+667]
   -0.000000000000000049*Close[i+668]
   +0.000000000000000052*Close[i+669]
   -0.000000000000000047*Close[i+670]
   +0.000000000000000050*Close[i+671]
   -0.000000000000000051*Close[i+672]
   +0.000000000000000050*Close[i+673]
   -0.000000000000000050*Close[i+674]
   +0.000000000000000050*Close[i+675]
   -0.000000000000000050*Close[i+676]
   +0.000000000000000050*Close[i+677]
   -0.000000000000000050*Close[i+678]
   +0.000000000000000051*Close[i+679]
   -0.000000000000000051*Close[i+680]
   +0.000000000000000050*Close[i+681]
   -0.000000000000000051*Close[i+682]
   +0.000000000000000051*Close[i+683]
   -0.000000000000000050*Close[i+684]
   +0.000000000000000051*Close[i+685]
   -0.000000000000000051*Close[i+686]
   +0.000000000000000051*Close[i+687]
   -0.000000000000000052*Close[i+688]
   +0.000000000000000051*Close[i+689]
   -0.000000000000000051*Close[i+690]
   +0.000000000000000052*Close[i+691]
   -0.000000000000000052*Close[i+692]
   +0.000000000000000051*Close[i+693]
   -0.000000000000000052*Close[i+694]
   +0.000000000000000051*Close[i+695]
   -0.000000000000000050*Close[i+696]
   +0.000000000000000050*Close[i+697]
   -0.000000000000000051*Close[i+698]
   +0.000000000000000052*Close[i+699]
   -0.000000000000000052*Close[i+700]
   +0.000000000000000052*Close[i+701]
   -0.000000000000000052*Close[i+702]
   +0.000000000000000052*Close[i+703]
   -0.000000000000000052*Close[i+704]
   +0.000000000000000051*Close[i+705]
   -0.000000000000000053*Close[i+706]
   +0.000000000000000052*Close[i+707]
   -0.000000000000000052*Close[i+708]
   +0.000000000000000053*Close[i+709]
   -0.000000000000000052*Close[i+710]
   +0.000000000000000052*Close[i+711]
   -0.000000000000000053*Close[i+712]
   +0.000000000000000052*Close[i+713]
   -0.000000000000000052*Close[i+714]
   +0.000000000000000053*Close[i+715]
   -0.000000000000000053*Close[i+716]
   +0.000000000000000052*Close[i+717]
   -0.000000000000000053*Close[i+718]
   +0.000000000000000052*Close[i+719]
   -0.000000000000000053*Close[i+720]
   +0.000000000000000051*Close[i+721]
   -0.000000000000000053*Close[i+722]
   +0.000000000000000053*Close[i+723]
   -0.000000000000000053*Close[i+724]
   +0.000000000000000054*Close[i+725]
   -0.000000000000000053*Close[i+726]
   +0.000000000000000053*Close[i+727]
   -0.000000000000000055*Close[i+728]
   +0.000000000000000053*Close[i+729]
   -0.000000000000000053*Close[i+730]
   +0.000000000000000053*Close[i+731]
   -0.000000000000000054*Close[i+732]
   +0.000000000000000053*Close[i+733]
   -0.000000000000000053*Close[i+734]
   +0.000000000000000053*Close[i+735]
   -0.000000000000000053*Close[i+736]
   +0.000000000000000054*Close[i+737]
   -0.000000000000000054*Close[i+738]
   +0.000000000000000054*Close[i+739]
   -0.000000000000000054*Close[i+740]
   +0.000000000000000054*Close[i+741]
   -0.000000000000000053*Close[i+742]
   +0.000000000000000054*Close[i+743]
   -0.000000000000000053*Close[i+744]
   +0.000000000000000054*Close[i+745]
   -0.000000000000000053*Close[i+746]
   +0.000000000000000054*Close[i+747]
   -0.000000000000000054*Close[i+748]
   +0.000000000000000053*Close[i+749]
   -0.000000000000000054*Close[i+750]
   +0.000000000000000054*Close[i+751]
   -0.000000000000000054*Close[i+752]
   +0.000000000000000054*Close[i+753]
   -0.000000000000000054*Close[i+754]
   +0.000000000000000054*Close[i+755]
   -0.000000000000000055*Close[i+756]
   +0.000000000000000055*Close[i+757]
   -0.000000000000000054*Close[i+758]
   +0.000000000000000055*Close[i+759]
   -0.000000000000000056*Close[i+760]
   +0.000000000000000055*Close[i+761]
   -0.000000000000000052*Close[i+762]
   +0.000000000000000054*Close[i+763]
   -0.000000000000000056*Close[i+764]
   +0.000000000000000054*Close[i+765]
   -0.000000000000000054*Close[i+766]
   +0.000000000000000055*Close[i+767]
   -0.000000000000000055*Close[i+768]
   +0.000000000000000055*Close[i+769]
   -0.000000000000000055*Close[i+770]
   +0.000000000000000055*Close[i+771]
   -0.000000000000000055*Close[i+772]
   +0.000000000000000056*Close[i+773]
   -0.000000000000000055*Close[i+774]
   +0.000000000000000054*Close[i+775]
   -0.000000000000000055*Close[i+776]
   +0.000000000000000056*Close[i+777]
   -0.000000000000000055*Close[i+778]
   +0.000000000000000056*Close[i+779]
   -0.000000000000000056*Close[i+780]
   +0.000000000000000056*Close[i+781]
   -0.000000000000000056*Close[i+782]
   +0.000000000000000056*Close[i+783]
   -0.000000000000000056*Close[i+784]
   +0.000000000000000056*Close[i+785]
   -0.000000000000000056*Close[i+786]
   +0.000000000000000056*Close[i+787]
   -0.000000000000000056*Close[i+788]
   +0.000000000000000056*Close[i+789]
   -0.000000000000000056*Close[i+790]
   +0.000000000000000056*Close[i+791]
   -0.000000000000000057*Close[i+792]
   +0.000000000000000056*Close[i+793]
   -0.000000000000000057*Close[i+794]
   +0.000000000000000056*Close[i+795]
   -0.000000000000000056*Close[i+796]
   +0.000000000000000055*Close[i+797]
   -0.000000000000000057*Close[i+798]
   +0.000000000000000057*Close[i+799]
   -0.000000000000000057*Close[i+800]
   +0.000000000000000057*Close[i+801]
   -0.000000000000000057*Close[i+802]
   +0.000000000000000057*Close[i+803]
   -0.000000000000000059*Close[i+804]
   +0.000000000000000058*Close[i+805]
   -0.000000000000000057*Close[i+806]
   +0.000000000000000062*Close[i+807]
   -0.000000000000000056*Close[i+808]
   +0.000000000000000058*Close[i+809]
   -0.000000000000000058*Close[i+810]
   +0.000000000000000058*Close[i+811]
   -0.000000000000000058*Close[i+812]
   +0.000000000000000057*Close[i+813]
   -0.000000000000000057*Close[i+814]
   +0.000000000000000058*Close[i+815]
   -0.000000000000000058*Close[i+816]
   +0.000000000000000058*Close[i+817]
   -0.000000000000000058*Close[i+818]
   +0.000000000000000059*Close[i+819]
   -0.000000000000000058*Close[i+820]
   +0.000000000000000058*Close[i+821]
   -0.000000000000000058*Close[i+822]
   +0.000000000000000058*Close[i+823]
   -0.000000000000000058*Close[i+824]
   +0.000000000000000059*Close[i+825]
   -0.000000000000000058*Close[i+826]
   +0.000000000000000058*Close[i+827]
   -0.000000000000000059*Close[i+828]
   +0.000000000000000059*Close[i+829]
   -0.000000000000000059*Close[i+830]
   +0.000000000000000059*Close[i+831]
   -0.000000000000000059*Close[i+832]
   +0.000000000000000059*Close[i+833]
   -0.000000000000000059*Close[i+834]
   +0.000000000000000059*Close[i+835]
   -0.000000000000000059*Close[i+836]
   +0.000000000000000060*Close[i+837]
   -0.000000000000000058*Close[i+838]
   +0.000000000000000060*Close[i+839]
   -0.000000000000000059*Close[i+840]
   +0.000000000000000062*Close[i+841]
   -0.000000000000000060*Close[i+842]
   +0.000000000000000060*Close[i+843]
   -0.000000000000000059*Close[i+844]
   +0.000000000000000062*Close[i+845]
   -0.000000000000000060*Close[i+846]
   +0.000000000000000060*Close[i+847]
   -0.000000000000000060*Close[i+848]
   +0.000000000000000060*Close[i+849]
   -0.000000000000000060*Close[i+850]
   +0.000000000000000061*Close[i+851]
   -0.000000000000000061*Close[i+852]
   +0.000000000000000060*Close[i+853]
   -0.000000000000000061*Close[i+854]
   +0.000000000000000060*Close[i+855]
   -0.000000000000000061*Close[i+856]
   +0.000000000000000061*Close[i+857];

   kgsp[i] = iDSmooth(value1,kgspSmoothLength,kgspSmoothPhase,kgspSmoothDouble,i, 0);
   }            
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
 
   double deviation = iStdDevOnArray(kgsp,0,VolatilityBandPeriod,0,VolatilityBandMAMode,i);
   double   average = iMAOnArray(kgsp,0,VolatilityBandPeriod,0,VolatilityBandMAMode,i);
       bandsUp[i] = average+VolatilityBandMultiplier*deviation;
       bandsDo[i] = average-VolatilityBandMultiplier*deviation;
       bandsMi[i] = average;
    
        kgspUa[i] = EMPTY_VALUE;
        kgspUb[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
 
     if (kgsp[i]>kgsp[i+1]) trend[i]= 1;
     if (kgsp[i]<kgsp[i+1]) trend[i]=-1;
     if (MultiColor && !calculateValue && trend[i]==-1) PlotPoint(i,kgspUa,kgspUb,kgsp);

     }
     
    manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (MultiColor && trend[limit]==-1) CleanPoint(limit,kgspUa,kgspUb);
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
          kgsp[i]    = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",kgspSmoothLength,kgspSmoothPhase,kgspSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,0,y);
          kgspUa[i]  = EMPTY_VALUE;
          kgspUb[i]  = EMPTY_VALUE;
          bandsMi[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",kgspSmoothLength,kgspSmoothPhase,kgspSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,3,y);
          bandsUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",kgspSmoothLength,kgspSmoothPhase,kgspSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,4,y);
          bandsDo[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",kgspSmoothLength,kgspSmoothPhase,kgspSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,5,y);
          trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",kgspSmoothLength,kgspSmoothPhase,kgspSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,6,y);  
          //
          //
          //
          //
          //
            
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
            
  	            kgsp[i+k]    = kgsp[i]    + (kgsp[i+n]    - kgsp[i])    * k/n;
  	            bandsMi[i+k] = bandsMi[i] + (bandsMi[i+n] - bandsMi[i]) * k/n;
  	            bandsUp[i+k] = bandsUp[i] + (bandsUp[i+n] - bandsUp[i]) * k/n;
  	            bandsDo[i+k] = bandsDo[i] + (bandsDo[i+n] - bandsDo[i]) * k/n;
  	            
           }  	            
           }
   
              if (MultiColor) for (i=limit;i>=0;i--) if (trend[i]==-1) PlotPoint(i,kgspUa,kgspUb,kgsp);
      
   manageAlerts();
      
   return(0);
}
         
//
//       
//
//
//+------------------------------------------------------------------+

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}


void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," kgsp changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," kgsp "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
  

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}